'==============================================================================
' Program:  PNGUI
' Autor:    Petr Krstev
' licence:  freeware (pro nekomern ely)
'==============================================================================
' Popis programu:
' Program byl napsn a odladn v PowerBasic for Windows 7.0 jako kzkov
' pro sout v programovn dt a mldee.
'==============================================================================
' Popis algoritmu:
' Vlastn vpoet b v samostatnm vlkn a probh na dv kola. Vpoet
' v samostatnm vlkn jsem zvolil pro hlad prbh a nastavil jsem mu nzkou
' prioritu procesu (IDLE). Grafick rozhran tak reaguje okamit a pokud m PC
' vce jader/procesor loha se rozdl mezi jdra a vpoet m jdro samo pro
' sebe. Program vytv v adresi, odkud je sputn, pracovn soubor. Mus
' k tomu mt dostaten prva a kapacitu disku (vce viz dle).
'
' Prvn kolo vpotu stanovuje tabulku prvosel, druh vybr vhodn dvojice
' prvosel a vypisuje je do souboru. Ob innosti sice lze udlat v jednom
' kole, ale je to pomalej a zdrojov text je mn pehledn.
'
' Prvn kolo - stanoven prvosel - pouv optimalizovan Erathostenovo sto,
' info viz napklad: http://rcernobila.czweb.org/algoritmy/erat.htm
' nebo obecn Google.
' Optimalizace je provedena tak, e jsou vynechny nsobky dvou, t a pti.
' Vykrtvn nsobk zan od sedminsobku, protoe vechny ostatn u jsou
' vykrtnuty, jde se po lichch nsobcch a konec je odmocnina(Limit).
'
' Data jsou ukldna do bitovho pole. Dky optimalizaci z kadch 30ti po sob
' jdoucch sel zbyde 8 sel, kter jsou potenciln (mon) prvosla. Ty
' jsou uloena do 8 bit, tedy prv do jednoho bytu. Vychz nm tedy poteba
' pamti na bitov pole takto: potreba_v_bytech = Limit / 30
' Pokud jsme schopni vytvoit bitov pole velikosti 2GB, meme toreticky
' potat s Limitem cca 60 miliard! Bude to ovem trvat dov dny vpotu.
' Praktick maximum je Limit = 2 miliardy s dobou vpotu nkolik minut.
' Bitov pole je ukldno pomoc pamov mapovanho souboru, co je zpsob,
' jak pracovat s velkmi soubory stejn rychle jako s pamt. Vstupnvstupn
' operace a mapovn provd jdro Windows a optimalizovan. Z hlediska
' programtora se jedn o prci s pamt a zle jen na programovacm
' prosted zda to podporuje. Technologick maximum mon dostupn pamti se
' li podle druhu a nastaven Windows. Pro Windows Xp Professional v zkladnm
' nastaven je to teoreticky 2GB. Bn je to o 100-200MB mn.
' S velikost operan pamti to nesouvis!
'
' Druh kolo - vpis dvojic prvosel do souboru je optimalizovn tm,
' e potenciln dvojice prvosel jsou vdy ve stejnm bytu a navc jsou
' bitov vedle sebe. Tak je mono je testovat jednm testem.
' Dvojice prvosel z prvn tictky se vypisuje explicitn, vechny ostatn se
' vypisuj podle zjitnch dat.
'==============================================================================

'------------------------------------------------------------------------------
' Metastatements
'------------------------------------------------------------------------------
#COMPILE EXE "PNGUI.exe"
#DIM ALL
#RESOURCE "PNGUI.pbr"

'------------------------------------------------------------------------------
' Initial Declares - eliminate unnecessary macros in COMMCTRL.INC
'------------------------------------------------------------------------------
%NOANIMATE         = 1  ' Animate control
%NOBUTTON          = 1  ' Button
%NOCOMBO           = 1  ' Combo box
%NOCOMBOEX         = 1  ' ComboBoxEx
%NODATETIMEPICK    = 1  ' Date/time picker
%NODRAGLIST        = 1  ' Drag list control
%NOEDIT            = 1  ' Edit control
%NOFLATSBAPIS      = 1  ' Flat scroll bar
%NOHEADER          = 1  ' Header control
%NOHOTKEY          = 1  ' HotKey control
%NOIMAGELIST       = 1  ' Image APIs
%NOIPADDRESS       = 1  ' IP Address edit control
%NOLIST            = 1  ' List box control
%NOLISTVIEW        = 1  ' ListView control
%NOMENUHELP        = 1  ' Menu help
%NOMONTHCAL        = 1  ' MonthCal
%NOMUI             = 1  ' MUI
%NONATIVEFONTCTL   = 1  ' Native Font control
%NOPAGESCROLLER    = 1  ' Pager
' %NOPROGRESS      = 1  ' Progress control
%NOREBAR           = 1  ' Rebar control
%NOSTATUSBAR       = 1  ' Status bar
%NOTABCONTROL      = 1  ' Tab control
%NOTOOLBAR         = 1  ' Tool bar
%NOTOOLTIPS        = 1  ' Tool tips
%NOTRACKBAR        = 1  ' Track bar
%NOTRACKMOUSEEVENT = 1  ' Track Mouse Event
%NOTREEVIEW        = 1  ' TreeView
%NOUPDOWN          = 1  ' Up Down arrow control


'------------------------------------------------------------------------------
' Include files
'------------------------------------------------------------------------------
#INCLUDE "WIN32API.INC"
#INCLUDE "COMDLG32.INC"
#INCLUDE "COMMCTRL.INC"
#INCLUDE "INITCTRL.INC"

'------------------------------------------------------------------------------
' Equates
'------------------------------------------------------------------------------
$AppTitle = "Prvosla lic se o 2 - Ukzkov program"
$WorkFile = "~data.tmp"

' Following constants are not in PB/DLL include files
%PAGE_READWRITE = &H004
' Control IDs
%ID_LBLPICK     = 100
%ID_LBLPN       = 101
%ID_LBLOUTFILE  = 102
%ID_LBLLIMIT    = 103
%ID_TXTLIMIT    = 104
%ID_TXTOUTFILE  = 105
%ID_OUTFILE     = 106
%ID_START       = 107
%ID_STOP        = 108
%ID_PRGSPN      = 109
%ID_PRGSPICK    = 110
%IDR_IMGFILE1   = 301

' Styles
%TBSTYLE = %WS_CHILD OR %WS_VISIBLE OR %ES_AUTOHSCROLL OR %WS_TABSTOP
%BTSTYLE = %WS_CHILD OR %WS_VISIBLE OR %BS_PUSHBUTTON OR %WS_TABSTOP
%PGSTYLE = %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER

' Global vars
GLOBAL C1           AS QUAD
GLOBAL C2           AS QUAD
GLOBAL Abort        AS INTEGER
GLOBAL Stage        AS INTEGER
GLOBAL Limit        AS QUAD
GLOBAL Total        AS QUAD
GLOBAL TimeElapsed  AS DOUBLE
GLOBAL OutFile      AS STRING
'Global Vars Mapping segment
GLOBAL hFile             AS LONG
GLOBAL hMap              AS LONG
GLOBAL dwFileSize        AS DWORD
GLOBAL ptrMapBuffer      AS BYTE PTR
GLOBAL ptrMapBufferOrig  AS BYTE PTR

DECLARE CALLBACK FUNCTION MainDlgProc

'= Working Part ==========================================================================================
FUNCTION Num2BRef(BYVAL Num AS QUAD, BYREF byteref AS QUAD, BYREF bitref AS BYTE) AS INTEGER
' pevod sla na poad bytu (byteref) a pozici v bytu (bitref) pro zajmav sla, vechny ostatn vrac nulu
    byteref = (num+1) \ 30
    SELECT CASE num MOD 30
        CASE 7
            bitref  = 1: FUNCTION = 1
        CASE 23
            bitref  = 2: FUNCTION = 1
        CASE 29
            bitref  = 4: FUNCTION = 1
        CASE 1
            bitref  = 8: FUNCTION = 1
        CASE 11
            bitref  = 16: FUNCTION = 1
        CASE 13
            bitref  = 32: FUNCTION = 1
        CASE 17
            bitref  = 64: FUNCTION = 1
        CASE 19
            bitref  = 128: FUNCTION = 1
        CASE ELSE
            bitref  = 0: FUNCTION = 0
    END SELECT
END FUNCTION

SUB SetPos(BYVAL Num AS QUAD)
' nastaven pozice Num na jedniku
    DIM byteref AS QUAD, bitref AS BYTE
    IF num2bref(num, byteref, bitref) THEN
        ptrMapBuffer = ptrMapBufferOrig + byteref
        @ptrMapBuffer = @ptrMapBuffer OR bitref
    END IF
END SUB

FUNCTION GetPos(BYVAL Num AS QUAD) AS BYTE
' zjitn stavu pozice Num
    DIM byteref AS QUAD, bitref AS BYTE
    IF num2bref(num, byteref, bitref) THEN
        ptrMapBuffer = ptrMapBufferOrig + byteref
        FUNCTION = @ptrMapBuffer AND bitref
    ELSE
        FUNCTION = 1
    END IF
END FUNCTION

SUB SetMultiple(BYVAL Mult AS QUAD)
' vykrtvn nsobk sla Mult
    DIM i AS QUAD, by AS QUAD, bi AS BYTE
    FOR i = 7 * mult TO limit STEP 2 * mult
        setpos i
    NEXT
END SUB

SUB SetPN()
' jdro Erathostena
    setmultiple 7  'vykrtme 7mi nsobky
    setmultiple 11 '11ti nsobky
    setmultiple 13 'atd
    setmultiple 17
    setmultiple 19
    setmultiple 23
    FOR C1 = 30 TO SQR(Limit) + 29 STEP 30
    'prochzme postupn jednotliv tictky a pokud najdeme prvoslo vykrtme jeho nsobky
        IF getpos(C1+7)=0 THEN setmultiple C1+7
        IF getpos(C1+23)=0 THEN setmultiple C1+23
        IF getpos(C1-1)=0 THEN setmultiple C1-1
        IF getpos(C1+1)=0 THEN setmultiple C1+1
        IF getpos(C1+11)=0 THEN setmultiple C1+11
        IF getpos(C1+13)=0 THEN setmultiple C1+13
        IF getpos(C1+17)=0 THEN setmultiple C1+17
        IF getpos(C1+19)=0 THEN setmultiple C1+19
        IF Abort THEN EXIT SUB
    NEXT
    Stage = 2
END SUB

SUB OutPN()
'vpis dvojic prvosel do pedem otevenho souboru
    DIM by AS QUAD, bi AS BYTE
    SELECT CASE limit
        CASE < 5
            total=0
        CASE 5,6
            total=1
            PRINT #2,FORMAT$(3) & " " & FORMAT$(5)
        CASE 7 TO 12
            total=2
            PRINT #2,FORMAT$(3) & " " & FORMAT$(5)
            PRINT #2,FORMAT$(5) & " " & FORMAT$(7)
        CASE 13 TO 18
            total=3
            PRINT #2,FORMAT$(3) & " " & FORMAT$(5)
            PRINT #2,FORMAT$(5) & " " & FORMAT$(7)
            PRINT #2,FORMAT$(11) & " " & FORMAT$(13)
        CASE 19 TO 29
            total=4
            PRINT #2,FORMAT$(3) & " " & FORMAT$(5)
            PRINT #2,FORMAT$(5) & " " & FORMAT$(7)
            PRINT #2,FORMAT$(11) & " " & FORMAT$(13)
            PRINT #2,FORMAT$(17) & " " & FORMAT$(19)
        CASE >=29
            total=4
            PRINT #2,FORMAT$(3) & " " & FORMAT$(5)
            PRINT #2,FORMAT$(5) & " " & FORMAT$(7)
            PRINT #2,FORMAT$(11) & " " & FORMAT$(13)
            PRINT #2,FORMAT$(17) & " " & FORMAT$(19)
            FOR C2=30 TO (Limit\30)*30-30 STEP 30
                IF (getpos(C2-1)=0) AND (getpos(C2+1)=0) THEN
                    PRINT #2,FORMAT$(C2-1) & " " & FORMAT$(C2+1)
                    INCR total
                END IF
                IF (getpos(C2+11)=0) AND (getpos(C2+13)=0) THEN
                    PRINT #2,FORMAT$(C2+11) & " " & FORMAT$(C2+13)
                    INCR total
                END IF
                IF (getpos(C2+17)=0) AND (getpos(C2+19)=0) THEN
                    PRINT #2,FORMAT$(C2+17) & " " & FORMAT$(C2+19)
                    INCR total
                END IF
                IF Abort THEN EXIT SUB
            NEXT
            REM print #2,"================================"
            FOR C2=(Limit\30)*30-1 TO limit-2 STEP 2
                IF (getpos(C2)=0) AND (getpos(C2+2)=0) THEN
                    PRINT #2,FORMAT$(C2) & " " & FORMAT$(C2+2)
                    INCR total
                END IF
                IF Abort THEN EXIT SUB
            NEXT
    END SELECT
    Stage = 3
END SUB

FUNCTION PrepareFile(FileName AS STRING) AS INTEGER
'Pprava pamov mapovanho souboru - v podstat opsno od MS z helpu k WIN32
    LOCAL dwErrCode         AS DWORD

    ' Open or Create the file
    hFile = CreateFile(BYVAL STRPTR(FileName), %GENERIC_READ OR %GENERIC_WRITE, 0, BYVAL %NULL, %OPEN_EXISTING, 0, BYVAL %NULL)

    dwErrCode = GetLastError()
    IF (hFile = %INVALID_HANDLE_VALUE) THEN
        MSGBOX "Failed to open " + FileName + $CRLF + $CRLF + "ERROR " + STR$(dwErrCode)
        FUNCTION = 0
        EXIT FUNCTION
    END IF

    hMap = CreateFileMapping(hFile, BYVAL %NULL, %PAGE_READWRITE, 0, 0, BYVAL %NULL)

    dwErrCode = GetLastError()
    IF (hMap = %NULL) THEN
        MSGBOX "Failed to create file mapping for " + FileName + $CRLF + $CRLF + "ERROR " + STR$(dwErrCode)
        CloseHandle hFile
        FUNCTION = 0
        EXIT FUNCTION
    END IF

    ' Get size of the file
    dwFileSize = GetFileSize(hFile, BYVAL %NULL)

    ' Create in memory a view into the file (in this case the whole
    ' file is included in the view)
    ptrMapBufferOrig = MapViewOfFile( hMap, %FILE_MAP_WRITE, BYVAL 0, BYVAL 0, BYVAL dwFileSize)

    dwErrCode = GetLastError()
    IF (ptrMapBufferOrig = 0) THEN
        MSGBOX "Failed to map " + FileName + $CRLF + $CRLF + "ERROR " + STR$(dwErrCode)
        CloseHandle hMap
        CloseHandle hFile
        FUNCTION = 0
        EXIT FUNCTION
    END IF

    FUNCTION = 1
END FUNCTION

SUB CleanUpFileMapping()
'Zvren klid pamov mapovanho souboru - v podstat opsno od MS z helpu k WIN32
    LOCAL dwErrCode         AS DWORD
    LOCAL dwResult          AS DWORD
    ' Write immediately back to disk - don't wait for OS to do it
    dwResult = FlushViewOfFile(BYVAL ptrMapBufferOrig, dwFileSize)
    dwErrCode = GetLastError()
    IF (dwResult = 0) THEN
        MSGBOX "Failed to write back to file" + $CRLF + $CRLF + "ERROR " + STR$(dwErrCode)
    END IF
    ' Clean up by releasing all handles
    UnmapViewOfFile ptrMapBufferOrig
    CloseHandle hMap
    CloseHandle hFile
END SUB

FUNCTION WorkThread(BYVAL y AS DWORD) AS DWORD
'Pracovn procedura spoutn jako vlkno
    DIM nula AS BYTE
    DIM TimeStart AS DOUBLE
    TimeStart = TIMER
    ON ERROR RESUME NEXT
    KILL $WorkFile
    ON ERROR GOTO 0
    OPEN $WorkFile FOR BINARY AS 1 BASE = 0
    PUT #1, (limit+29) \ 30, nula 'alokace souboru o potebn velikosti
    CLOSE 1
    IF PrepareFile($WorkFile) THEN 'pokud se poda otevt pracovn soubor
        SetPN 'vyhledme prvosla
        OPEN OutFile FOR OUTPUT AS 2 'oteveme vstupn textov soubor
        OutPN 'vypeme dvojice
        CLOSE 2 'zaveme soubor
        CleanUpFileMapping 'uklidme pracovn soubor
    END IF
    TimeElapsed=TIMER - TimeStart
    Abort = %TRUE
END FUNCTION

'=========================================================================================================
' GUI Generated Part
CALLBACK FUNCTION MainDlgProc
    DIM hTimer AS DWORD
    DIM Lim AS STRING
    DIM hThread&
    STATIC sLimit AS QUAD
    SELECT CASE CBMSG
        CASE %WM_INITDIALOG
            ' Ensures all controls are drawn before starting
            DIALOG REDRAW CBHNDL
        CASE %WM_COMMAND
            IF CBCTLMSG = %BN_CLICKED THEN
                SELECT CASE CBCTL
                    CASE %ID_OUTFILE
                        DIM FName AS STRING
                        DIM FPath AS STRING
                        FName = "Out.txt"
                        IF SaveFileDialog(CBHNDL, "Vstupn soubor?", FName, FPath, _
                                    "Text Files|*.txt|All Files|*.*", "txt", %OFN_HIDEREADONLY OR %OFN_LONGNAMES ) THEN
                            'MSGBOX FName & FPath
                            CONTROL SET TEXT CBHNDL, %ID_TXTOUTFILE, FName & FPath
                        END IF
                        FUNCTION = 1
                    CASE %ID_START
                        IF Stage THEN EXIT SELECT
                        CONTROL GET TEXT CBHNDL, %ID_TXTOUTFILE TO OutFile
                        CONTROL GET TEXT CBHNDL, %ID_TXTLIMIT TO Lim
                        Limit = VAL(Lim)
                        sLimit = SQR(Limit)
                        Abort = %FALSE
                        Stage = 1
                        C1 = 0
                        C2 = 0
                        CONTROL SEND CBHNDL, %ID_PRGSPN, %PBM_SETRANGE, 0, MAKLNG(0, 100)
                        CONTROL SEND CBHNDL, %ID_PRGSPICK, %PBM_SETRANGE, 0, MAKLNG(0, 100)
                        CONTROL SEND CBHNDL, %ID_PRGSPN, %PBM_SETPOS, 0, 0
                        CONTROL SEND CBHNDL, %ID_PRGSPICK, %PBM_SETPOS, 0, 0
                        DIALOG SET TEXT CBHNDL, $AppTitle & " - Potm..."
                        MOUSEPTR 11
                        THREAD CREATE WorkThread( 0 ) TO hThread&
                        'hTimer = GetThreadPriority(hThread&)
                        'msgbox format$(hTimer)
                        hTimer = SetThreadPriority(hThread&,%THREAD_PRIORITY_IDLE)
                        hTimer = SetTimer(CBHNDL, 0, 50, BYVAL %NULL)
                        FUNCTION = 1
                    CASE %ID_STOP
                        Abort = %TRUE
                        FUNCTION = 1
                END SELECT
            END IF
        CASE %WM_TIMER
            IF Abort THEN
                KillTimer CBHNDL, 0
                MOUSEPTR 1
                IF Stage = 3 THEN
                    CONTROL SEND CBHNDL, %ID_PRGSPN, %PBM_SETPOS, 100, 0
                    CONTROL SEND CBHNDL, %ID_PRGSPICK, %PBM_SETPOS, 100, 0
                    DIALOG SET TEXT CBHNDL, $AppTitle & " - Dokoneno"
                    MSGBOX "Celkov mnostv dvojic je: " & FORMAT$(Total,"### ### ### ### ###") & $CRLF & _
                        FORMAT$(TimeElapsed) & "s, (" & FORMAT$(Limit/(TimeElapsed)) & "/s).",, "Vsledek:"
                ELSE
                    DIALOG SET TEXT CBHNDL, $AppTitle & " - Perueno (" & FORMAT$(Stage) & ")"
                END IF
                Stage = 0
            ELSE
                SELECT CASE Stage
                    CASE 1
                        CONTROL SEND CBHNDL, %ID_PRGSPN, %PBM_SETPOS, (C1*100) \ sLimit, 0
                        'control set text cbhndl, %ID_TXTLIMIT, format$(C1)
                    CASE 2
                        CONTROL SEND CBHNDL, %ID_PRGSPICK, %PBM_SETPOS, (C2*100) \ Limit, 0
                END SELECT
            END IF
            FUNCTION = 1
    END SELECT
END FUNCTION

'------------------------------------------------------------------------------
' Main entry point for the application
'------------------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG
    LOCAL    hDlg    AS DWORD
    LOCAL    Result  AS LONG
    LOCAL    hPopup1 AS DWORD
    LOCAL    hPopup2 AS DWORD
    LOCAL    nFile   AS LONG

    ' Initialize the common control library for the floating toolbar
    CALL InitComCtl32()

    ' Create our primary GUI
    DIALOG NEW 0, "",,, 272, 165, %DS_CENTER OR %WS_CAPTION OR %WS_SYSMENU, 0 TO hDlg

    ' Abort if the dialog could not be created
    IF hDlg = 0 THEN EXIT FUNCTION  ' Error occurred

    DIALOG SET TEXT hDlg, $AppTitle
    DIALOG SET ICON hDlg, "#" + FORMAT$(%IDR_IMGFILE1)

    'Labels
    CONTROL ADD LABEL, hDlg,  %ID_LBLPICK,  "Vyhledvn a vstup dvojic", 11, 133, 123, 10
    CONTROL ADD LABEL, hDlg,  %ID_LBLPN,  "Vpoet prvosel", 11, 101, 123, 10
    CONTROL ADD LABEL, hDlg,  %ID_LBLOUTFILE,  "Vstupn soubor:", 11, 42, 109, 10
    CONTROL ADD LABEL, hDlg,  %ID_LBLLIMIT,  "Limit", 11, 10, 109, 7
    'Textboxes
    CONTROL ADD TEXTBOX, hDlg,  %ID_TXTLIMIT,  "100000000", 11, 20, 240, 12, %TBSTYLE OR %ES_NUMBER, %WS_EX_CLIENTEDGE
    CONTROL ADD TEXTBOX, hDlg,  %ID_TXTOUTFILE,  "Out.txt", 11, 52, 240, 12, %TBSTYLE, %WS_EX_CLIENTEDGE
    'Buttons
    CONTROL ADD "Button", hDlg,  %ID_OUTFILE,  "...", 251, 52, 13, 12, %BTSTYLE
    CONTROL ADD "Button", hDlg,  %ID_START,  "&Start", 11, 71, 53, 15, %BTSTYLE
    CONTROL ADD "Button", hDlg,  %ID_STOP,  "S&top", 75, 71, 53, 15, %BTSTYLE
    'Progress bars
    CONTROL ADD "msctls_progress32", hDlg,  %ID_PRGSPN,  "", 11, 111, 240, 10, %PGSTYLE
    CONTROL ADD "msctls_progress32", hDlg,  %ID_PRGSPICK,  "", 11, 143, 240, 10, %PGSTYLE

    DIALOG SHOW MODAL hDlg, CALL MainDlgProc

END FUNCTION
